# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   test61
# FileName:      read_ini.py
# Author:       lao_zhao
# Datetime:     2024/7/12 14:03
# Description:
# 
# ---------------------------------------------------------------------------
import configparser
import os.path


class ReadIni:
    def __init__(self, username):
        """获取ini文件的路径，并读取"""
        self.username_data_config_path = os.path.join(os.path.join(os.path.dirname(os.path.dirname(__file__)), "data_config"), username)
        ini_path = os.path.join(self.username_data_config_path, "config.ini")
        self.conf = configparser.ConfigParser()
        self.conf.read(ini_path, encoding="utf-8")

    def get_file_path(self, key):
        """根据key，获取file节点下文件的路径"""
        try:
            file_name = self.conf.get("file", key)
        except Exception as e:
            raise e
        else:
            return os.path.join(self.username_data_config_path, file_name)

    # def get_url(self, key):
    #     """根据key，获取被测系统的域名"""
    #     try:
    #         return self.conf.get("host", key)
    #     except Exception as e:
    #         raise e

    def get_table_name(self, key):
        """根据key获取工作表的名称"""
        try:
            return self.conf.get("table_name", key)
        except Exception as e:
            raise e
    #
    # def sql_connect_msg(self, key):
    #     """根据key，获取数据库的链接信息"""
    #     try:
    #         return self.conf.get("sql", key)
    #     except Exception as e:
    #         raise e
